// WinMain.cpp
#include <windows.h>
#include "../DLLWrapper/ExportedMain.h"



int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nShowCmd)
{
	MessageBox (NULL, "launcher start", "launcher", MB_OK);

#if 1
	HMODULE hModule = LoadLibrary ("prog1.dll");
	if (hModule) {
		fpExportedMain fp = (fpExportedMain) GetProcAddress (hModule, "ExportedMain");
		if (fp) {
			fp (hInst, hPrevInst, lpCmdLine, nShowCmd);
		} else {
			MessageBox (NULL, "Failed at GetProcAddress ()", "launcher", MB_OK);
		}
		FreeLibrary (hModule);
	} else {
		MessageBox (NULL, "Failed at LoadLibrary ()", "launcher", MB_OK);
	}
#else
	// CreateProcess gꍇ
	PROCESS_INFORMATION pi;
	STARTUPINFO si = { 0 };
	si.cb = sizeof (si);
	CreateProcess (
			NULL,
			(LPTSTR)"../prog1/prog1.exe",
			NULL, NULL,
			FALSE,
			NORMAL_PRIORITY_CLASS,
			NULL, NULL,
			&si, &pi);
	// pi.hProcess : NvZX̃vZXnh
#endif

	return MessageBox (NULL, "launcher terminated", "launcher", MB_OK);
}